#!/bin/sed -nrf

:CommentHandle
x; /^<\/!-->/{
  x; /--]/{
    H; s;^(.*)--].*$;\1-->;p;
    g; s;^.*--]([^\n]*)$;\1;
    x; s;^</!-->\n(.*)\n[^\n]*$;\1;; x;
    bCommentEnd
  }
  p; b;
}
x;
:CommentEnd

:shortcuts
s;\[hidden[ \t]+"([^"]*)"[ \t]+"([^"]*)";[input type="hidden" name="\1" value="\2";g;
s;\[checkbox[ \t]+"([^"]*)"[ \t]+"([^"]*)";[input type="checkbox" name="\1" value="\2";g;
s;\[radio[ \t]+"([^"]*)"[ \t]+"([^"]*)";[input type="radio" name="\1" value="\2";g;
s;\[submit[ \t]+"([^"]*)"[ \t]+"([^"]*)";[button type="submit" name="\1" value="\2";g;
s;\[a[ \t]+"([^"]*)";[a href="\1";g;
s;\[img[ \t]+"([^"]*)"[ \t]+"([^"]*)";[img src="\1" alt="\2";g;

s;\[!([^]\[]*)\];<!\1>;g;
s;\[!--([^]\[]*)--\];<!--\1-->;g;

:tags
s;\[([^]\[< \t]+)([^]\[]*)\];<\1>\2</\1>;g;
t tags;

G;
:tagclose
s;^([^]\n]*)\]([^\n]*)\n([^\n]+);\1\3\2;
t tagclose;
h; s;^([^\n]*)\n;;; x; s;\n.*$;;;

:tagopen
s;^([^\[\n]*)\[([^]\[< \t\n]+)([^\n]*);\1<\2>\3\n</\2>;
t tagopen;
G; h; s;^[^\n]*\n+;;; x; s;\n.*$;;;

:attribs
s;class="([^>]+)>[ \t]+\.([^< \t]+);class="\2 \1>;g; t attribs;
s;>[ \t]+\.([^< \t]+); class="\1">;g;
s;>[ \t]+#([^< \t]+); id="\1">;g;
s;>[ \t]+([^ \t=<]+=("[^"]*"|'[^']*'|[^< \t]*)); \1>;g;
s;(<input type="(checkbox|radio)" [^>]+)>[ \t]+checked;\1 checked="checked">;g;
t attribs;

s;(<[^/][^>]*>)[ \t]*;\1;g;
s;(<[^/][^>]*)>[ \t]*</[^>]+>;\1/>;g;

s;<!-->;<!--;;

p; ${g; s;\n+;;g; p;}
